# BACnet Server Example Proprietary Property CSharp

A basic BACnet IP server example written in CSharp using the [CAS BACnet Stack](https://www.bacnetstack.com/). In this example we show how to add a proprietary property to a device object. 

- device: 389001  (Device name Rainbow)
  - Property 513 = "Proprietary property 513 readonly" (CharString)
  - Property 514 = "Proprietary property 514 read/write" (CharString)

## Example output

```txt
Starting Windows-BACnetServerExampleProprietaryPropertyCSharp version0.0.1.0
https://github.com/chipkin/BACnetServerExampleProprietaryPropertyCSharp
FYI: BACnet Stack version: 3.8.3.0
FYI: CAS BACnet Stack Setup, successfuly
FYI: Starting main loop
FYI: Recving 12 bytes from 192.168.1.26:47808
FYI: Sending 25 bytes to 192.168.1.26:47808
FYI: Recving 19 bytes from 192.168.1.26:47808
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=12, propertyArrayIndex=0
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=44, propertyArrayIndex=0
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=70, propertyArrayIndex=0
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=77, propertyArrayIndex=0
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=121, propertyArrayIndex=0
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=513, propertyArrayIndex=0
FYI: Request for CallbackGetPropertyCharString. objectType=8, objectInstance=389001, propertyIdentifier=514, propertyArrayIndex=0
FYI: Sending 340 bytes to 192.168.1.26:47808
FYI: Recving 19 bytes from 192.168.1.26:47808
FYI: Sending 25 bytes to 192.168.1.26:47808
```

## Building

A [Visual studio 2019](https://visualstudio.microsoft.com/downloads/) project is included with this project.

This project also auto built using [Gitlab CI](https://docs.gitlab.com/ee/ci/) on every commit.
