#ifndef __CASBACnetStackExampleConstants_h__
#define __CASBACnetStackExampleConstants_h__

/*
This is a fully static class that contains all the constants used by the example

This includes Object Types, Property Identifiers, etc
*/

#include "datatypes.h"

class CASBACnetStackExampleConstants {

public:
	// Object Types
	static const uint16_t OBJECT_TYPE_ANALOG_INPUT = 0;
	static const uint16_t OBJECT_TYPE_ANALOG_OUTPUT = 1;
	static const uint16_t OBJECT_TYPE_ANALOG_VALUE = 2;
	static const uint16_t OBJECT_TYPE_BINARY_INPUT = 3;
	static const uint16_t OBJECT_TYPE_BINARY_OUTPUT = 4;
	static const uint16_t OBJECT_TYPE_BINARY_VALUE = 5;
	//static const uint16_t OBJECT_TYPE_CALENDAR = 6;
	//static const uint16_t OBJECT_TYPE_COMMAND = 7;
	static const uint16_t OBJECT_TYPE_DEVICE = 8;
	//static const uint16_t OBJECT_TYPE_EVENT_ENROLLMENT = 9;
	//static const uint16_t OBJECT_TYPE_FILE = 10;
	//static const uint16_t OBJECT_TYPE_GROUP = 11;
	//static const uint16_t OBJECT_TYPE_LOOP = 12;
	static const uint16_t OBJECT_TYPE_MULTI_STATE_INPUT = 13;
	static const uint16_t OBJECT_TYPE_MULTI_STATE_OUTPUT = 14;
	//static const uint16_t OBJECT_TYPE_NOTIFICATION_CLASS = 15;
	//static const uint16_t OBJECT_TYPE_PROGRAM = 16;
	//static const uint16_t OBJECT_TYPE_SCHEDULE = 17;
	//static const uint16_t OBJECT_TYPE_AVERAGING = 18;
	static const uint16_t OBJECT_TYPE_MULTI_STATE_VALUE = 19;
	static const uint16_t OBJECT_TYPE_TREND_LOG = 20;
	//static const uint16_t OBJECT_TYPE_LIFE_SAFETY_POINT = 21;
	//static const uint16_t OBJECT_TYPE_LIFE_SAFETY_ZONE = 22;
	//static const uint16_t OBJECT_TYPE_ACCUMULATOR = 23;
	//static const uint16_t OBJECT_TYPE_PULSE_CONVERTER = 24;
	//static const uint16_t OBJECT_TYPE_EVENT_LOG = 25;
	//static const uint16_t OBJECT_TYPE_GLOBAL_GROUP = 26;
	//static const uint16_t OBJECT_TYPE_TREND_LOG_MULTIPLE = 27;
	//static const uint16_t OBJECT_TYPE_LOAD_CONTROL = 28;
	//static const uint16_t OBJECT_TYPE_STRUCTURED_VIEW = 29;
	//static const uint16_t OBJECT_TYPE_ACCESS_DOOR = 30;
	//static const uint16_t OBJECT_TYPE_TIMER = 31;
	//static const uint16_t OBJECT_TYPE_ACCESS_CREDENTIAL = 32;
	//static const uint16_t OBJECT_TYPE_ACCESS_POINT = 33;
	//static const uint16_t OBJECT_TYPE_ACCESS_RIGHTS = 34;
	//static const uint16_t OBJECT_TYPE_ACCESS_USER = 35;
	//static const uint16_t OBJECT_TYPE_ACCESS_ZONE = 36;
	//static const uint16_t OBJECT_TYPE_CREDENTIAL_DATA_INPUT = 37;
	//static const uint16_t OBJECT_TYPE_NETWORK_SECURITY = 38;
	static const uint16_t OBJECT_TYPE_BITSTRING_VALUE = 39;
	static const uint16_t OBJECT_TYPE_CHARACTERSTRING_VALUE = 40;
	//static const uint16_t OBJECT_TYPE_DATEPATTERN_VALUE = 41;
	static const uint16_t OBJECT_TYPE_DATE_VALUE = 42;
	//static const uint16_t OBJECT_TYPE_DATETIMEPATTERN_VALUE = 43;
	//static const uint16_t OBJECT_TYPE_DATETIME_VALUE = 44;
	static const uint16_t OBJECT_TYPE_INTEGER_VALUE = 45;
	static const uint16_t OBJECT_TYPE_LARGE_ANALOG_VALUE = 46;
	static const uint16_t OBJECT_TYPE_OCTETSTRING_VALUE = 47;
	static const uint16_t OBJECT_TYPE_POSITIVE_INTEGER_VALUE = 48;
	//static const uint16_t OBJECT_TYPE_TIMEPATTERN_VALUE = 49;
	static const uint16_t OBJECT_TYPE_TIME_VALUE = 50;
	//static const uint16_t OBJECT_TYPE_NOTIFICATION_FORWARDER = 51;
	//static const uint16_t OBJECT_TYPE_ALERT_ENROLLMENT = 52;
	//static const uint16_t OBJECT_TYPE_CHANNEL = 53;
	//static const uint16_t OBJECT_TYPE_LIGHTING_OUTPUT = 54;
	//static const uint16_t OBJECT_TYPE_BINARY_LIGHTING_OUTPUT = 55;
	static const uint16_t OBJECT_TYPE_NETWORK_PORT = 56;
	//static const uint16_t OBJECT_TYPE_ELEVATOR_GROUP = 57;
	//static const uint16_t OBJECT_TYPE_ESCALATOR = 58;
	//static const uint16_t OBJECT_TYPE_LIFT = 59;

	// Property Identifiers
	static const uint32_t PROPERTY_IDENTIFIER_ALL = 8;
	static const uint32_t PROPERTY_IDENTIFIER_COV_INCREMENT = 22;
	static const uint32_t PROPERTY_IDENTIFIER_DAY_LIGHT_SAVINGS_STATUS = 24;
	static const uint32_t PROPERTY_IDENTIFIER_LOCAL_DATE = 56;
	static const uint32_t PROPERTY_IDENTIFIER_LOCAL_TIME = 57;
	static const uint32_t PROPERTY_IDENTIFIER_OBJECT_NAME = 77;
	static const uint32_t PROPERTY_IDENTIFIER_PRESENT_VALUE = 85;
	static const uint32_t PROPERTY_IDENTIFIER_PRIORITY_ARRAY = 87;
	static const uint32_t PROPERTY_IDENTIFIER_RELINQUISH_DEFAULT = 104;
	static const uint32_t PROPERTY_IDENTIFIER_UTC_OFFSET = 119;
	static const uint32_t PROPERTY_IDENTIFIER_LOG_BUFFER = 131;
	static const uint32_t PROPERTY_IDENTIFIER_ACTIVE_COV_SUBSCRIPTIONS = 152;
	
	// Services Supported
	static const uint8_t SERVICE_CONFIRMED_COV_NOTIFICATION = 1;
	static const uint8_t SERVICE_SUBSCRIBE_COV = 5;
	static const uint8_t SERVICE_READ_PROPERTY_MULTIPLE = 14;
	static const uint8_t SERVICE_WRITE_PROPERTY = 15;
	static const uint8_t SERVICE_WRITE_PROPERTY_MULTIPLE = 16;
	static const uint8_t SERVICE_I_AM = 26;
	static const uint8_t SERVICE_I_HAVE = 27;
	static const uint8_t SERVICE_UNCONFIRMED_COV_NOTIFICATION = 28;
	static const uint8_t SERVICE_TIME_SYNCHRONIZATION = 32;
	static const uint8_t SERVICE_UTC_TIME_SYNCHRONIZATION = 36;
		
	// Error Codes
	static const uint8_t ERROR_NO_SPACE_TO_WRITE_PROPERTY = 20;
	static const uint8_t ERROR_VALUE_OUT_OF_RANGE = 37;

	// Primitive Datatypes
	static const uint8_t BACNET_DATATYPE_NULL = 0;
	static const uint8_t BACNET_DATATYPE_BOOLEAN = 1;
	static const uint8_t BACNET_DATATYPE_UNSIGNED_INTEGER = 2;
	static const uint8_t BACNET_DATATYPE_SIGNED_INTEGER = 3;
	static const uint8_t BACNET_DATATYPE_REAL = 4;
	static const uint8_t BACNET_DATATYPE_DOUBLE = 5;
	static const uint8_t BACNET_DATATYPE_OCTET_STRING = 6;
	static const uint8_t BACNET_DATATYPE_CHARACTER_STRING = 7;
	static const uint8_t BACNET_DATATYPE_BIT_STRING = 8;
	static const uint8_t BACNET_DATATYPE_ENUMERATED = 9;
	static const uint8_t BACNET_DATATYPE_DATE = 10;
	static const uint8_t BACNET_DATATYPE_TIME = 11;

	// Reinitialized State of Device
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_COLDSTART = 0;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_WARMSTART = 1;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_STARTBACKUP = 2;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_ENDBACKUP = 3;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_STARTRESTORE = 4;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_ENDRESTORE = 5;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_ABORTRESTORE = 6;
	static const uint8_t BACNET_REINITIALIZED_STATE_OF_DEVICE_ACTIVATECHANGES = 7;

	// Enable/Disable
	static const uint8_t BACNET_ENABLE_DISABLE_ENABLE = 0;
	static const uint8_t BACNET_ENABLE_DISABLE_DISABLE = 1;
	static const uint8_t BACNET_ENABLE_DISABLE_DISABLE_INITIATION = 2;

};

#endif // __CASBACnetStackExampleConstants_h__
